FROM rust:1.81.0-slim-bookworm
RUN apt-get update && \
    apt-get install -yq --no-install-recommends \
        libc-dev \
        protobuf-compiler \
        gcc \
        g++ \
        libpq-dev \
        libssl-dev \
        pkg-config \
        python3 \
        openjdk-17-jdk \
        pdf2svg \
        make \
        pypy3 \
        texlive-full \
        librsvg2-bin \
        pandoc && \
    apt-get clean && \
    rm -rf /var/lib/apt/lists/*
RUN rustup component add rustfmt
RUN --mount=type=cache,target=/usr/local/cargo/registry \
    --mount=type=cache,target=/usr/local/cargo/git \
    cargo install systemfd && \
    cargo install cargo-watch
WORKDIR /usr/src/jughisto
CMD systemfd --no-pid -s http::0.0.0.0:8000 -- cargo watch -w src -x 'run --color always' -i alvokanto/
