// @generated automatically by Diesel CLI.

diesel::table! {
    backup (uuid) {
        uuid -> Text,
        filename -> Text,
        contents -> Bytea,
        creation_instant -> Timestamp,
        contest_id -> Int4,
        user_id -> Int4,
    }
}

diesel::table! {
    clarification (uuid) {
        uuid -> Text,
        question -> Text,
        question_instant -> Timestamp,
        answer -> Nullable<Text>,
        answer_instant -> Nullable<Timestamp>,
        answer_user_id -> Nullable<Int4>,
        answer_to_all -> Bool,
        contest_problem_id -> Nullable<Int4>,
        contest_id -> Int4,
        user_id -> Int4,
    }
}

diesel::table! {
    contest (id) {
        id -> Int4,
        name -> Text,
        start_instant -> Nullable<Timestamp>,
        end_instant -> Nullable<Timestamp>,
        creation_user_id -> Int4,
        creation_instant -> Timestamp,
        grade_ratio -> Nullable<Int4>,
        grade_after_ratio -> Nullable<Int4>,
        frozen_scoreboard_instant -> Nullable<Timestamp>,
        blind_scoreboard_instant -> Nullable<Timestamp>,
    }
}

diesel::table! {
    contest_problems (id) {
        id -> Int4,
        label -> Text,
        contest_id -> Int4,
        problem_id -> Text,
        balloon_color -> Nullable<Text>,
        problem_name_override -> Nullable<Text>,
    }
}

diesel::table! {
    printing_task (uuid) {
        uuid -> Text,
        contents -> Text,
        creation_instant -> Timestamp,
        status -> Text,
        done_instant -> Nullable<Timestamp>,
        contest_id -> Int4,
        user_id -> Int4,
    }
}

diesel::table! {
    problem (id) {
        id -> Text,
        name -> Text,
        memory_limit_bytes -> Int4,
        time_limit_ms -> Int4,
        status -> Text,
        creation_user_id -> Int4,
        creation_instant -> Timestamp,
        repository_id -> Nullable<Int4>,
    }
}

diesel::table! {
    repository (id) {
        id -> Int4,
        name -> Text,
        path -> Text,
        remote_url -> Text,
        creation_user_id -> Int4,
        creation_instant -> Timestamp,
    }
}

diesel::table! {
    submission (uuid) {
        uuid -> Text,
        verdict -> Nullable<Text>,
        source_text -> Text,
        language -> Text,
        submission_instant -> Timestamp,
        judge_start_instant -> Nullable<Timestamp>,
        judge_end_instant -> Nullable<Timestamp>,
        memory_kib -> Nullable<Int4>,
        time_ms -> Nullable<Int4>,
        time_wall_ms -> Nullable<Int4>,
        error_output -> Nullable<Text>,
        contest_problem_id -> Int4,
        user_id -> Int4,
        failed_test -> Nullable<Int4>,
        balloon_delivered_instant -> Nullable<Timestamp>,
    }
}

diesel::table! {
    user (id) {
        id -> Int4,
        name -> Text,
        hashed_password -> Text,
        is_admin -> Bool,
        creation_user_id -> Nullable<Int4>,
        creation_instant -> Timestamp,
        full_name -> Nullable<Text>,
        single_contest_id -> Nullable<Int4>,
    }
}

diesel::joinable!(backup -> contest (contest_id));
diesel::joinable!(backup -> user (user_id));
diesel::joinable!(clarification -> user (user_id));
diesel::joinable!(clarification -> contest (contest_id));
diesel::joinable!(clarification -> contest_problems (contest_problem_id));
diesel::joinable!(contest_problems -> contest (contest_id));
diesel::joinable!(contest_problems -> problem (problem_id));
diesel::joinable!(printing_task -> contest (contest_id));
diesel::joinable!(printing_task -> user (user_id));
diesel::joinable!(problem -> repository (repository_id));
diesel::joinable!(problem -> user (creation_user_id));
diesel::joinable!(repository -> user (creation_user_id));
diesel::joinable!(submission -> contest_problems (contest_problem_id));
diesel::joinable!(submission -> user (user_id));

diesel::allow_tables_to_appear_in_same_query!(
    backup,
    clarification,
    contest,
    contest_problems,
    printing_task,
    problem,
    repository,
    submission,
    user,
);
